; Prozeduren zur grafischen Darstellung



; ---------------------------------------------------------------------------------------

; Prozedur zum Zeichnen eines einzelnen Tile
Procedure draw_small_tile(nr.w, x.w, y.w, offset_x.b, offset_y.b)

shared sprite_x, sprite_y

zw.w

  if nr < 89   ; ueber 88 ist was besonderes (wie pilze)
     sprite_x.w = nr
     sprite_y.w = 0
     if sprite_x > 10
        repeat
           sprite_y = sprite_y + 1
	   sprite_x = sprite_x - 10
        until sprite_x < 11
     endif
     if sprite_x = 10
        sprite_x = 0
        sprite_y = sprite_y + 1
     endif
     ClipSprite(#SPRITE_TILESET_SMALLLABYRINTH, sprite_x*16, sprite_y*16, 16, 16)
     DisplaySprite(#SPRITE_TILESET_SMALLLABYRINTH, x*16+offset_x, y*16+offset_y)
  endif
  if nr > 88 and nr < 201
     sprite_x = 4
     sprite_y = 0
     ClipSprite(#SPRITE_TILESET_SMALLLABYRINTH, 128, 0, 16, 16)
     DisplaySprite(#SPRITE_TILESET_SMALLLABYRINTH, x*16+offset_x, y*16+offset_y)
  endif
  if nr > 200   ; Monster
        zw = nr
        zw = zw - 200
        sprite_x.w = zw
        sprite_y.w = 0
        if sprite_x > 10
           repeat
              sprite_y = sprite_y + 1
	      sprite_x = sprite_x - 10
           until sprite_x < 11
        endif
	ClipSprite(#SPRITE_TILESET_SMALLLABYRINTH, 128, 0, 32, 32)
        DisplaySprite(#SPRITE_TILESET_SMALLLABYRINTH, x*16+offset_x, y*16+offset_y)  ; Erst Gang
        ClipSprite(#SPRITE_TILESET_SMALLMONSTER, sprite_x*16-16, sprite_y*16, 16, 16)
        DisplaytransparentSprite(#SPRITE_TILESET_SMALLMONSTER, x*16+offset_x, y*16+offset_y)  ; Dann Monster Transparent
  endif


EndProcedure

; ---------------------------------------------------------------------------------------

; Prozedur zum Zeichnen des Charakters
Procedure draw_character(face.b, frame.b)

shared spieler, akt_spieler

  ClipSprite(#SPRITE_TILESET_CHARACTER, face*32*2+frame*32, spieler(akt_spieler) \maennchen*32-32, 32, 32)
  DisplayTransparentSprite(#SPRITE_TILESET_CHARACTER, 5*32, 5*32)

EndProcedure


; --------------------------------------------------------------------------------------

; Prozedur zum Zeichnen eines einzelnen Tile
Procedure draw_tile(nr.w, x.w, y.w, offset_x.b, offset_y.b)

shared sprite_x, sprite_y

zw.w

  if nr < 89   ; ueber 88 ist was besonderes (wie pilze)
     sprite_x.w = nr
     sprite_y.w = 0
     if sprite_x > 10
        repeat
           sprite_y = sprite_y + 1
	   sprite_x = sprite_x - 10
        until sprite_x < 11
     endif
     if sprite_x = 10
        sprite_x = 0
        sprite_y = sprite_y + 1
     endif
     ClipSprite(#SPRITE_TILESET_LABYRINTH, sprite_x*32, sprite_y*32, 32, 32)
     DisplaySprite(#SPRITE_TILESET_LABYRINTH, x*32+offset_x, y*32+offset_y)
  endif
  if nr > 88 and nr < 201
     sprite_x = 4
     sprite_y = 0
     ClipSprite(#SPRITE_TILESET_LABYRINTH, 128, 0, 32, 32)
     DisplaySprite(#SPRITE_TILESET_LABYRINTH, x*32+offset_x, y*32+offset_y)
  endif
  if nr > 200   ; Monster
        zw = nr
        zw = zw - 200
        sprite_x.w = zw
        sprite_y.w = 0
        if sprite_x > 10
           repeat
              sprite_y = sprite_y + 1
	      sprite_x = sprite_x - 10
           until sprite_x < 11
        endif
	ClipSprite(#SPRITE_TILESET_LABYRINTH, 128, 0, 32, 32)
        DisplaySprite(#SPRITE_TILESET_LABYRINTH, x*32+offset_x, y*32+offset_y)  ; Erst Gang
        ClipSprite(#SPRITE_TILESET_MONSTER, sprite_x*32-32, sprite_y*32, 32, 32)
        DisplaytransparentSprite(#SPRITE_TILESET_MONSTER, x*32+offset_x, y*32+offset_y)  ; Dann Monster Transparent
  endif


EndProcedure

; --------------------------------------------------------------------------------------

; Prozedur zum Zeichnen des Haupt-Bildschirms
Procedure draw_screen(x_offset.b, y_offset.b)

  Shared spieler, akt_spieler,frame, anz_spieler
  For y.b=-1 To 11
    For x.b=-1 To 11
      if spieler(akt_spieler) \character_x-5+x < 1 or spieler(akt_spieler) \character_y-5+y < 1
         draw_tile(1, x, y, x_offset, y_offset)   ; Mauer
      else

         draw_tile(labyrinth(spieler(akt_spieler) \character_x-5+x, spieler(akt_spieler) \character_y-5+y) \feld, x, y, x_offset, y_offset)


	 for xx = 1 to anz_spieler
	    if xx <> akt_spieler
	       if spieler(akt_spieler) \character_x-5+x = spieler(xx) \character_x and spieler(akt_spieler) \character_y-5+y = spieler(xx) \character_y
                  ClipSprite(#SPRITE_TILESET_CHARACTER, spieler(xx) \face*32*2, spieler(xx) \maennchen*32-32, 32, 32)
                  DisplayTransparentSprite(#SPRITE_TILESET_CHARACTER, x*32+x_offset, y*32+y_offset)
	       endif
	    endif
	 next


      endif
    Next
  Next

EndProcedure

; --------------------------------------------------------------------------------------

; Prozedur zum zeichnen von Karten

procedure karte(x_offset.b, y_offset.b)

 Shared spieler, akt_spieler

   repeat

      clearscreen(0,0,0)

      For y.b=-1 To 20
         For x.b=-1 To 20
            if spieler(akt_spieler) \character_x-5+x < 1 or spieler(akt_spieler) \character_y-5+y < 1
               draw_small_tile(1, x, y, x_offset, y_offset)   ; Mauer
            else
               draw_small_tile(labyrinth(spieler(akt_spieler) \character_x-5+x, spieler(akt_spieler) \character_y-5+y) \feld, x, y, x_offset, y_offset)
            endif
         Next
      Next

   laby_rahmen()
   show_logo()
   show_varys()
   show_buttons()

      result = ExamineMouse()
      mouse_x = mousex()
      mouse_y = mousey()
      mouse_links = 0
      mouse_rechts = 0
      mouse_links  = Mousebutton(1)
      mouse_rechts = Mousebutton(2)
      ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mouse_x, mouse_y)
     FlipBuffers()
   until mouse_rechts = 1

endprocedure

; --------------------------------------------------------------------------------------

; Prozedur zum kompletten Zeichnen des Hauptbildschirms (inkl. Charakter, FlipBuffer etc.)
Procedure draw_screen_total()

  Shared spieler, akt_spieler, frame
  ClearScreen(0, 0, 0)
  draw_screen(0 , 0)
  draw_character(spieler(akt_spieler) \face, frame)
      result = ExamineMouse()
      mouse_x = mousex()
      mouse_y = mousey()
      mouse_links = 0
      mouse_rechts = 0
      mouse_links  = Mousebutton(1)
      mouse_rechts = Mousebutton(2)
      ok_button = 0
      ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mouse_x, mouse_y)
  FlipBuffers()

EndProcedure
